org.restlet

## Class Connector

- java.lang.Object
- - org.restlet.Restlet
  - - org.restlet.Connector

All Implemented Interfaces:
  Uniform

Direct Known Subclasses:
  Client, Server

    public abstract class Connector
    extends Restlet

Restlet enabling communication between Components. "A connector is an abstract mechanism that mediates communication, coordination, or cooperation among components. Connectors enable communication between components by transferring data elements from one interface to another without changing the data." Roy T. Fielding
"Encapsulate the activities of accessing resources and transferring resource representations. The connectors present an abstract interface for component communication, enhancing simplicity by providing a clean separation of concerns and hiding the underlying implementation of resources and communication mechanisms" Roy T. Fielding
Concurrency note: instances of this class or its subclasses can be invoked by several threads at the same time and therefore must be thread-safe. You should be especially careful when storing state in member variables.

Author:
  Jerome Louvel
See Also:
  Source dissertation, Source dissertation

### Constructor Summary

Constructors
Constructor and Description
`Connector(Context context)` Constructor.
`Connector(Context context, java.util.List<Protocol> protocols)` Constructor.

### Method Summary

Methods
`java.util.List<Protocol>` `getProtocols()` Returns the modifiable list of protocols simultaneously supported.
`abstract boolean` `isAvailable()` Indicates the underlying connector helper is available.
`void` `setProtocols(java.util.List<Protocol> protocols)` Sets the list of protocols simultaneously supported.

### Methods inherited from class org.restlet.Restlet

`finalize, getApplication, getAuthor, getContext, getDescription, getLogger, getName, getOwner, handle, isStarted, isStopped, setAuthor, setContext, setDescription, setName, setOwner, start, stop`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Connector

    public Connector(Context context)

Constructor.

Parameters:
  `context` - The context.

#### Connector

    public Connector(Context context,
             java.util.List<Protocol> protocols)

Constructor.

Parameters:
  `context` - The context.
  `protocols` - The supported protocols.

### Method Detail

#### getProtocols

    public java.util.List<Protocol> getProtocols()

Returns the modifiable list of protocols simultaneously supported.

Returns:
  The protocols simultaneously supported.

#### isAvailable

    public abstract boolean isAvailable()

Indicates the underlying connector helper is available.

Returns:
  True if the underlying connector helper is available.

#### setProtocols

    public void setProtocols(java.util.List<Protocol> protocols)

Sets the list of protocols simultaneously supported. This method clears the current list and adds all entries in the parameter list.

Parameters:
  `protocols` - A list of protocols.